#include <assert.h>
#include <stdio.h>
 
float QuickSort(int [], int);
float SeqMergeSort(int [], int);
float ParMergeSort(int [], int, int);

static const unsigned base_size = 1024*1024;
static const unsigned max_size = base_size*256;
static const unsigned max_depth = 4;
static int T[max_size];

static void generate(int size)
  { int x, y;
    for (x = 0, y = 1; x < size; x += 1, y = (y + 4253171) % 1235711)
      T[x] = y; }

static void validate(int size)
  { int x, y;
    for (x = 1, y = T[0]; x < size; y = T[x], x += 1)
      assert (y <= T[x]); }

int main(int argc, const char * argv[])
  { float ref;
    float time;
    for (unsigned size = 16*base_size; size <= max_size; size = 2*size)
      { printf("ParMergeSort of %d integers\n", size);
        for (unsigned depth = 0; depth <= max_depth; depth +=1)
          { float time;
            generate(size);
            time = ParMergeSort(T, size, depth);
            if (depth == 0)
              ref = time;
            printf("  spawning depth = %d - elapsed time = %8.5f - speed up = %8.5f\n",
                   depth, time, ref / time);
            validate(size); }
        generate(size);
        printf("QuickSort of %d integers\n", size);
        time = QuickSort(T, size);
        printf("  elapsed time = %8.5f\n", time);
        validate(size);
        generate(size);
        printf("SeqMergeSort of %d integers\n", size);
        time = SeqMergeSort(T, size);
        printf("  elapsed time = %8.5f\n", time);
        validate(size); }
    return 0; }
